<?php
// Get the names and values for vars sended by index.lib.php3
if (isset($HTTP_GET_VARS))
{
	while(list($name,$value) = each($HTTP_GET_VARS))
	{
		$$name = $value;
	};
};

// Get the names and values for post vars
if (isset($HTTP_POST_VARS))
{
	while(list($name,$value) = each($HTTP_POST_VARS))
	{
		$$name = $value;
	};
};

require("config/config.lib.php3");
require("localization/".$L.".lang.php3");
require("lib/release.lib.php3");
require("lib/database/".C_DB_TYPE.".lib.php3");
require("lib/clean.lib.php3");

header("Content-Type: text/html; charset=${Charset}");

// avoid server configuration for magic quotes
set_magic_quotes_runtime(0);

$DbLink = new DB;

$U = urldecode($U);
$R = urldecode($R);

// ** Updates user info in connected users tables **
$DbLink->query("SELECT status,room FROM ".C_USR_TBL." WHERE username = '$U' LIMIT 1");
if ($DbLink->num_rows() != 0)
{
	list($status,$room) = $DbLink->next_record();
	$DbLink->clean_results();
	$kicked = 0;
	if ($room != stripslashes($R))	// Same nick in another room
	{
		$DbLink->query("INSERT INTO ".C_MSG_TBL." VALUES ($T, '$R', '', '', ".time().", '', '/exit $U')");
		$kicked = 3;
	}
	elseif ($status == "k")			// Kicked by a moderator or the admin.
	{
		$DbLink->query("INSERT INTO ".C_MSG_TBL." VALUES ($T, '$R', '', '', ".time().", '', '/exit $U')");
		$kicked = 1;
	}
	elseif ($status == "d")			// The admin just deleted the room
	{
		$kicked = 2;
	}
	if ($kicked > 0)
	{
		// Kick the user from the current room
		?>
		<SCRIPT TYPE="text/javascript" LANGUAGE="JavaScript">
		<!--
		parent.location = '<?php echo("$From?L=$L&U=".urlencode(stripslashes($U))."&E=".urlencode(stripslashes($R))."&KICKED=${kicked}"); ?>';
		// -->
		</SCRIPT>
		<?php
		$DbLink->close();
		exit;
	}
}
else
{
	$DbLink->clean_results();
}


// ** Message colors for JavaScript1.1+ enabled browsers **
if ($Ver != "L")
{
	unset($TextColors);
	$TextColors = array(
		"#FF0000","#FF0099","#FF00FF","#CC00FF","#9900FF","#6600FF","#000099","#0000FF","#0066FF",
		"#00CCFF","#00FFFF","#00FF66","#009900","#006600","#999900","#99CC00","#FFFF00","#FF9900",
		"#FF6600","#996633","#990000","#660000","#000000","#666666","#999999"
	);
};


// ** Send formated messages to the message table **
function AddMessage($M, $T, $R, $U, $C, $Private)
{
	global $DbLink;

	if(C_HTML_TAGS_KEEP == "none")
	{
		if(C_HTML_TAGS_SHOW == 0)
		{
			// eliminates every HTML like tags
			$M = ereg_replace("<[^>]+>", "", $M);
		}
		else
		{
			// or keep it without effect
			$M = str_replace("<", "&lt;", $M);
			$M = str_replace(">", "&gt;", $M);
		}
	}
	else
	{
		// then C_HTML_TAGS_KEEP == "simple", we keep U, B and I tags
		$M = str_replace("<", "&lt;", $M);
		$M = str_replace(">", "&gt;", $M);

		if(function_exists("preg_match"))
		{
			while(preg_match("/&lt;([ubi]?)&gt;(.*?)&lt;(\/\\1)&gt;/i",$M))
			{
				$M = preg_replace("/&lt;([ubi]?)&gt;(.*?)&lt;(\/\\1)&gt;/i","<\\1>\\2<\\3>",$M);
			}
			if(C_HTML_TAGS_SHOW == 0)
			{
				$M = preg_replace("/&lt;\/?[ubi]?&gt;/i","",$M);
			}
		}
	}

	// URL
	$M = eregi_replace("([[:alnum:]]+)://([^[:space:]]*)([[:alnum:]#\?/&=])", "<a href=\"\\1://\\2\\3\" target=\"_blank\">\\1://\\2\\3</A>", $M);

	// Smilies
	if(C_USE_SMILIES == 1)
	{
		$M = ereg_replace(":\)", " <IMG SRC=\"images/smilies/smile1.gif\" WIDTH=15 HEIGHT=15 ALT=\":)\"> ", $M);
		$M = ereg_replace(":D", " <IMG SRC=\"images/smilies/smile2.gif\" WIDTH=15 HEIGHT=15 ALT=\":D\"> ", $M);
		$M = ereg_replace(":o", " <IMG SRC=\"images/smilies/smile3.gif\" WIDTH=15 HEIGHT=15 ALT=\":o\"> ", $M);
		$M = ereg_replace(":\(", " <IMG SRC=\"images/smilies/smile4.gif\" WIDTH=15 HEIGHT=15 ALT=\":(\"> ", $M);
		$M = ereg_replace(";\)", " <IMG SRC=\"images/smilies/smile5.gif\" WIDTH=15 HEIGHT=15 ALT=\";)\"> ", $M);
		$M = ereg_replace(":p", " <IMG SRC=\"images/smilies/smile6.gif\" WIDTH=15 HEIGHT=15 ALT=\":p\"> ", $M);
		$M = ereg_replace("8\)", " <IMG SRC=\"images/smilies/smile7.gif\" WIDTH=15 HEIGHT=15 ALT=\"8)\"> ", $M);
		$M = ereg_replace(":\[", " <IMG SRC=\"images/smilies/smile8.gif\" WIDTH=15 HEIGHT=15 ALT=\":[\"> ", $M);
		$M = ereg_replace(":kill:", "<IMG SRC=\"images/smilies/smile9.gif\" WIDTH=50 HEIGHT=15 ALT=\":kill:\">", $M);
	}

	// e-mail addresses
	$M = eregi_replace("(([a-z0-9_]|\\-|\\.)+@([^[:space:]]*)([[:alnum:]-])\.([^[:space:]]*)([[:alnum:]-]))", "<a href=\"mailto:\\1\">\\1</a>", $M);

	// transform ISO-8859-1 special characters
	global $Charset;
	$Latin1 = ($Charset == "iso-8859-1");
	if ($Latin1)
	{
		global $MsgTo;
		ereg("(.*)(".$MsgTo."(&gt;)?)(.*)",$M,$Regs);
		if ($MsgTo != "" && ($Regs[1] == "" && $Regs[4] == "")) $Regs[4] = $M;
		if (!ereg("&[[:alnum:]]{1,10};",$Regs[1]) && !ereg("&[[:alnum:]]{1,10};",$Regs[4]))
		{
			for ($i = 1; $i <= 4; $i++)
			{
				if (($i != 1 && $i != 4) || $Regs[$i] == "") continue;
				$part = $Regs[$i];
				$part = htmlentities($part);
				$part = str_replace("&lt;", "<", $part);
				$part = str_replace("&gt;", ">", $part);
				$part = str_replace("&amp;lt;", "&lt;", $part);
				$part = str_replace("&amp;gt;", "&gt;", $part);
				$part = str_replace("&quot;","\"", $part);
				$part = ereg_replace("&amp;(#[[:digit:]]{2,5};)", "&\\1", $part);
				$Regs[$i] = $part;
			}
			$M = $Regs[1].$Regs[2].$Regs[4];
		}
	}

	$M = "<FONT COLOR=\"".$C."\">".$M."</FONT>";

	$DbLink->query("INSERT INTO ".C_MSG_TBL." VALUES ($T, '$R', '".addslashes($U)."', '$Latin1', ".time().", '$Private', '".addslashes($M)."')");
}


// ** Define the default color that will be used for messages **
if (isset($HTTP_COOKIE_VARS["CookieColor"])) $CookieColor = $HTTP_COOKIE_VARS["CookieColor"];
if(!isset($C))
{
	if(!isset($CookieColor))
	{
		// set default color to black
		$C = "#000000";
	}
	else
	{
		$C = $CookieColor;
	}
};
setcookie("CookieColor", $C, time() + 60*60*24*365);        // cookie expires in one year


// ** Test for online commands and bad words **
$IsCommand = false;
$RefreshMessages = false;
$IsPopup = false;
$IsM = false;

if (isset($M) && trim($M) != "" && ereg("^\/", $M)) include("commands.php3");

if (isset($M) && ereg("^\/", $M) && !($IsCommand) && !isset($Error)) $Error = L_BAD_CMD;

if (isset($M) && trim($M) != "" && !($IsCommand || isset($Error)))
{
	if (C_BAD_WORDS == 1)
	{
		include("lib/swearing.lib.php3");
		$M = checkwords($M, false);
	}
	AddMessage(stripslashes($M), $T, $R, $U, $C, "");
	if (!C_USE_PERSISTENT) $RefreshMessages = true;
}

$DbLink->close();
?>
<HTML>

<HEAD>
<LINK REL="stylesheet" HREF="config/style.css.php3?<?php echo("Charset=${Charset}&medium=${FontSize}"); ?>" TYPE="text/css">
<SCRIPT TYPE="text/javascript" LANGUAGE="JavaScript">
<!--
function help_popup()
{
	window.open("help_popup.php3?<?php echo("L=$L"); ?>","help_popup","width=600,height=350,scrollbars=yes,resizable=yes");
}
// -->
</SCRIPT>
<SCRIPT TYPE="text/javascript" LANGUAGE="JavaScript1.1">
<!--
// Set the focus to the message box; 
function get_focus()
{
	window.focus();
	document.Form.M.focus();
}

// Color choice; 
image1 = new Image(4,20);
image1.src = "images/unselColor.gif";
image2 = new Image(4,20);
image2.src = "images/selColor.gif";
var SelColor = null;

function ChangeColor(ColorVal,ColorRank)
{
	if (SelColor != ColorRank)
	{
		if (document.all)
		{
			obj1 = document.all[SelColor];
			obj2 = document.all[ColorRank];
		}
		else if (document.images)
		{
			obj1 = document.images[SelColor];
			obj2 = document.images[ColorRank];
		}
		else return;

		if (SelColor != null)
		{
			obj1.src = image1.src;
		}
		SelColor = ColorRank;
		document.Form.C.value = ColorVal;
		obj2.src = image2.src;
	}
	document.Form.M.focus();
}
// -->
</SCRIPT>
</HEAD>

<BODY CLASS=frame <?php if (!$IsPopup) echo("onLoad=\"if (window.focus) get_focus();\""); ?>>
<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>
<TR>

	<!-- Input form  -->

	<TD>
	<FORM NAME="Form" ACTION="input.php3" METHOD=POST>
		<INPUT TYPE="hidden" NAME="From" VALUE="<?php echo($From); ?>">
		<INPUT TYPE="hidden" NAME="Ver" VALUE="<?php echo($Ver); ?>">
		<INPUT TYPE="hidden" NAME="L" VALUE="<?php echo($L); ?>">
		<INPUT TYPE="hidden" NAME="U" VALUE="<?php echo(htmlspecialchars(stripslashes(urlencode($U)))); ?>">
		<INPUT TYPE="hidden" NAME="R" VALUE="<?php echo(htmlspecialchars(stripslashes(urlencode($R)))); ?>">
		<INPUT TYPE="hidden" NAME="T" VALUE="<?php echo($T); ?>">
		<INPUT TYPE="hidden" NAME="D" VALUE="<?php echo($D); ?>">
		<INPUT TYPE="hidden" NAME="N" VALUE="<?php echo($N); ?>">
		<INPUT TYPE="hidden" NAME="O" VALUE="<?php echo($O); ?>">
		<INPUT TYPE="hidden" NAME="ST" VALUE="<?php echo($ST); ?>">
		<INPUT TYPE="hidden" NAME="NT" VALUE="<?php echo($NT); ?>">
		<INPUT TYPE="hidden" NAME="PWD" VALUE="<?php echo($PWD); ?>">
		<?php
		if (isset($Ign))
		{
			?>
			<INPUT TYPE="hidden" NAME="Ign" VALUE="<?php echo(htmlspecialchars(stripslashes($Ign))); ?>">
			<?php
		}
		if (isset($M))		// Store the last sended message or command for the /! command
		{
			?>
			<INPUT TYPE="hidden" NAME="M0" VALUE="<?php echo(htmlspecialchars(stripslashes($M))); ?>">
			<?php
		}
		?>
		<A HREF="help_popup.php3?<?php echo("L=$L"); ?>" onClick="help_popup(); return false" TARGET="_blank"><IMG SRC="images/help.gif" WIDTH=15 HEIGHT=15 BORDER=0 ALT="<?php echo(L_HLP); ?>" onClick="document.Form.M.focus();"></A>&nbsp;
		<?php
		// Get the value to put in the message box : preceding M0 field value for /! command,
		// preceding entry if it was an erroneous command, else nothing; 
		$ValM = $IsM ? $M0 : "";
		if (isset($Error) && !($IsCommand)) $ValM = $M;
		?>
		<INPUT TYPE="text" NAME="M" SIZE="50" MAXLENGTH="299" VALUE="<?php echo(htmlspecialchars(stripslashes($ValM))); ?>">
		<INPUT TYPE="hidden" NAME="MsgTo" VALUE="">
		<?php
		if ($Ver == "L")
		{
			// Drop down list of colors for non-enabled JavaScript1.1+ browsers
			echo("<SELECT NAME=\"C\">\n");
			while(list($ColorName, $ColorCode) = each($TextColors))
			{
					echo("<OPTION VALUE=\"".$ColorCode."\"");
					if($C == $ColorCode || $ColorCode == "#000000") echo(" SELECTED");
					echo(">".$ColorName."</OPTION>");
			}
			echo("\n</SELECT>&nbsp;\n");
		}
		else
		{
			?>
			<INPUT TYPE="hidden" NAME="C" VALUE="<?php echo($C); ?>">
			<?php
		}
		?>
		<INPUT TYPE="submit" VALUE="OK">
	</TD>

	<?php
	if ($Ver != "L")
	{
		// Colors picker for JavaScript1.1+ enabled browsers
		?>
		<TD>&nbsp;&nbsp;</TD>
		<TD>
		<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>
		<TR HEIGHT=20>
			<?php
			while(list($key, $ColorCode) = each($TextColors))
			{
				$i = $key + 1;
				if ($ColorCode == $C)
				{
					$wichImage = "selColor.gif";
					$wichSelected = $i;
				}
				else
				{
					$wichImage = "unselColor.gif";
				}
				?>
				<TD BGCOLOR="<?php echo($ColorCode); ?>"><A HREF="javascript:ChangeColor('<?php echo($ColorCode); ?>','<?php echo("C${i}"); ?>');"><IMG SRC="images/<?php echo($wichImage); ?>" ALT="<?php echo($ColorCode); ?>" NAME="<?php echo("C${i}"); ?>" BORDER=0 WIDTH=4 HEIGHT=20></A></TD>
				<?php
			}
			?>
		</TR>
		</TABLE>
		</TD>
		<TD></FORM></TD>
		<?php
	}
	?>
</TR>
</TABLE>

<?php
// ** Ensure a color is selected in the colors picker, else select the default one (black) **
if ($Ver != "L")
{
	?>
	<SCRIPT TYPE="text/javascript" LANGUAGE="JavaScript">
	<!--
	<?php
	if (isset($wichSelected))
	{
		?>
		SelColor = "<?php echo("C${wichSelected}"); ?>";
		<?php
	}
	else
	{
		?>
		ChangeColor("#000000","C23");
		<?php
	}
	?>
	// -->
	</SCRIPT>
	<?php
}

// ** Refresh the messages frame if necessary **
if($RefreshMessages)
{
	$Tmp = isset($Ign) ? "&Ign=".urlencode(stripslashes($Ign)) : "";
	?>
	<SCRIPT TYPE="text/javascript" LANGUAGE="JavaScript">
	<!--
	parent.messages.location = 'messages.php3?<?php echo("From=".urlencode($From)."&L=$L&U=".urlencode(stripslashes($U))."&R=".urlencode(stripslashes($R))."&T=$T&D=$D&N=$N&O=$O&ST=$ST&NT=$NT".$Tmp); ?>';
	// -->
	</SCRIPT>
	<?php
}

// ** Display a JavaScript alert box with the error message if necessary **
if(isset($Error))
{
	?>
	<SCRIPT TYPE="text/javascript" LANGUAGE="JavaScript">
	<!--
	document.Form.M.select();
	alert("<?php echo(addslashes($Error)); ?>");
	// -->
	</SCRIPT>
	<?php
}
?>
</BODY>

</HTML>
