<?php
// Get the names and values for vars sended to index.lib.php3
if (isset($HTTP_GET_VARS))
{
	while(list($name,$value) = each($HTTP_GET_VARS))
	{
		$$name = $value;
	};
};

require("${ChatPath}config/config.lib.php3");
require("${ChatPath}localization/languages.lib.php3");
require("${ChatPath}localization/".$L.".lang.php3");
require("${ChatPath}lib/release.lib.php3");
require("${ChatPath}lib/database/".C_DB_TYPE.".lib.php3");
require("${ChatPath}lib/clean.lib.php3");

header("Expires: Sun, 28 Dec 1997 09:32:45 GMT");
header("Cache-Control: no-cache, must-revalidate");
header("Pragma: no-cache");
header("Content-Type: text/html; charset=${Charset}");

// avoid server configuration for magic quotes
set_magic_quotes_runtime(0);

// Get the names and values for vars posted from the form bellow
if (isset($HTTP_POST_VARS))
{
	while(list($name,$value) = each($HTTP_POST_VARS))
	{
		$$name = $value;
	};
};

// Get the relative path to the script that called this one
if (!isset($PHP_SELF)) $PHP_SELF = $HTTP_SERVER_VARS["PHP_SELF"];
ereg("[^/]+$", $PHP_SELF, $Regs);
$Action = $Regs[0];
$From = urlencode(ereg_replace("[^/]+/","../",$ChatPath).$Action);
unset($Regs);

$DbLink = new DB;

function Url($str)
{
	return urlencode(stripslashes($str));
}

// Define the message to display if user comes here because he has been kicked
if (isset($KICKED))
{
	switch ($KICKED)
	{
		case '1':
			$Error = L_REG_18;
			break;
		case '2':
			$Error = L_REG_39;
			break;
		case '3':
			$Error = L_ERR_USR_19;
	}
}

// Removes user from users table and if necessary add a notication message for him
if(isset($E) && $E != "")
{
	if (isset($EN)) $DbLink->query("INSERT INTO ".C_MSG_TBL." VALUES ($EN, '$E', '', '', ".time().", '', '/exit $U')");
	$DbLink->query("DELETE FROM ".C_USR_TBL." WHERE username='$U' AND room='$E'");
}

// If no room is specified but the main form has been posted, define the room to enter
// in as the first among default ones
if ((isset($Form_Send) && $Form_Send) && (((C_VERSION == 0) || ($R0 == "" && $R1 == "" && $R2 == "")))) $R0 = $DefaultChatRooms[0];


//**	Ensures the nick is a valid one except if the frameset is reloaded because of the
//		NN4+ resize bug or because the user runs a join command.	**
if(!isset($Reload) && isset($U) && (isset($N) && $N != ""))
{
	$relog = false;
	if (C_BAD_WORDS == 1) include("${ChatPath}lib/swearing.lib.php3");
	// Check for no nick entered in
	if ($U == "")
	{
		$Error = L_ERR_USR_2;
	}
	// Check for invalid characters or empty nick
	elseif (trim($U) == "" || ereg("[\, ]", stripslashes($U)))
	{
		$Error = L_ERR_USR_16;
	}
	// Check for bad words in the nick
	elseif (C_BAD_WORDS == 1 && checkwords($U, true))
	{
		$Error = L_ERR_USR_18;
	}
	else
	{
		$DbLink->query("SELECT room FROM ".C_USR_TBL." WHERE username='$U' LIMIT 1");
		$Nb = $DbLink->num_rows();
		// If the same nick is already in use and the user is not registered deny access
		if($Nb != 0 && $PASSWORD == "" && !isset($PWD))
		{
			$Error = L_ERR_USR_1;
			$DbLink->clean_results();
		}
		else
		{
			list($room) = $DbLink->next_record();
			$DbLink->clean_results();
			$DbLink->query("SELECT password,perms,rooms FROM ".C_REG_TBL." WHERE username='$U' LIMIT 1");
			$reguser = ($DbLink->num_rows() != 0);
			if ($reguser) list($user_password,$perms,$rooms) = $DbLink->next_record();
			$DbLink->clean_results();

			if (!(isset($E) && $E != ""))
			{
				// Check for password if the nick exist in registered users table
				if ($reguser)
				{
					if ($PASSWORD == "" && !isset($PWD))
					{
						$Error = L_ERR_USR_3;
					}
					else
					{
						if (md5(stripslashes($PASSWORD)) != $user_password && $PWD != $user_password) $Error = L_ERR_USR_4;
					}
					if (!isset($Error)) $DbLink->query("UPDATE ".C_REG_TBL." SET reg_time=".time()." WHERE username='$U'");
				}
				// If users isn't a registered one and phpMyChat require registration deny access
				else if (C_REQUIRE_REGISTER)
				{
					$Error = L_ERR_USR_14;
				}
			}

			// The var bellow is set to 1 when a registered user is allowed to log using a nick
			// that already exist in the users table
			$relog = ($Nb != 0 && !isset($Error));

			$CookieUsername = urlencode(stripslashes($U));
			setcookie("CookieUsername", $CookieUsername, time() + 60*60*24*365);        // cookie expires in one year
		}
	}
}


// **	Get perms of the user if the script is called by a join command	**
if (isset($Reload) && $Reload == "JoinCmd")
{
	$DbLink->query("SELECT perms,rooms FROM ".C_REG_TBL." WHERE username='$U' LIMIT 1");
	list($perms,$rooms) = $DbLink->next_record();
	$DbLink->clean_results();
}


// **	Ensures the user can create a room and the room name is a valid one (bypassed test
//		when the frameset is reloaded because of the NN4+ resize bug).	**
if(!isset($Error) && (isset($R2) && $R2 != ""))
{
	// Skipped when the script is called by a join command.
	if (!isset($Reload))
	{
		// User is not registered -> Deny room creation
		if (!$reguser)
		{
			$Error = L_ERR_USR_13;
		}
		// Check for invalid characters or empty room name
		else if (trim($R2) == "" || ereg("[\,]", stripslashes($R2)))
		{
			$Error = L_ERR_ROM_1;
		}
		// Check for bad words in room name
		else if(C_BAD_WORDS == 1 && checkwords($R2, true))
		{
			$Error = L_ERR_ROM_2;
		}
		// Ensure there is no existing room with the same name but a different type
		else
		{
			$T1 = 1 - $T;
			$DbLink->query("SELECT count(*) FROM ".C_MSG_TBL." WHERE room = '$R2' AND type = '$T1' LIMIT 1");
			list($Nb) = $DbLink->next_record();
			$DbLink->clean_results();
			if($Nb != 0) $Error = ($T == 0 ? L_ERR_ROM_3:L_ERR_ROM_4);
		}
	}

	// Define the user status
	if (!isset($Error))
	{
		$register_room = true;
		// If room name is the same than one of the default rooms names, status will be 'user'.
		// Skipped when the script is called by a join command.
		if (!isset($Reload))
		{
			for ($i = 0; $i < count($DefaultChatRooms); $i++)
			{
				if (eregi($R2,$DefaultChatRooms[$i])) $register_room = false;
			}
		};

		// If room name is the same than one of an existing room containing "true" messages
		// (not only notifications of users entrance/exit) or containing only "system"
		// message but an other user is already logged in, status will be 'user'
		// Note: "LEFT JOIN" is not a valid statement for PostgreSQL at this time. So two
		// queries are required to do the work
		if (C_DB_TYPE == "pgsql")
		{
			if ($register_room)
			{
				$DbLink->query("SELECT Count(*) FROM ".C_MSG_TBL." WHERE room='$R2' AND username != '' LIMIT 1");
				list($count) = $DbLink->next_record();
				$register_room = ($count == 0);
				$DbLink->clean_results();
			}

			if ($register_room)
			{
				$DbLink->query("SELECT count(*) FROM ".C_USR_TBL." WHERE room='$R2' AND username != '$U' LIMIT 1");
				list($anybody) = $DbLink->next_record();
				$register_room = ($anybody == 0);
				$DbLink->clean_results();
			}
		}
		else
		{
			if ($register_room)
			{
				$DbLink->query("SELECT Count(*) FROM ".C_MSG_TBL." m LEFT JOIN ".C_USR_TBL." u ON m.username = u.username WHERE m.room = '$R2' AND m.username != '' LIMIT 1");
				list($count) = $DbLink->next_record();
				$register_room = ($count == "0");
				$DbLink->clean_results();
			}
		};

		if ($register_room)
		{
			// If an other registered user is already moderator for the room to be created but
			// there is no "true" message in this room then set his status to user for this room
			$UpdLink = new DB;
			$DbLink->query("SELECT username,rooms FROM ".C_REG_TBL." WHERE perms = 'moderator' AND username != '$U'");
			while (list($mod_un,$mod_rooms) = $DbLink->next_record())
			{
				if (eregi($R2,$mod_rooms))
				{
					$mod_rooms = eregi_replace($R2,"",$mod_rooms);
					$mod_rooms = ereg_replace("^,|,$","",str_replace(",,",",",$mod_rooms));
					$UpdLink->query("UPDATE ".C_REG_TBL." SET rooms='".addslashes($mod_rooms)."' WHERE username='".addslashes($mod_un)."'");
					$UpdLink->query("UPDATE ".C_USR_TBL." SET status='' WHERE room='$R2' AND username='".addslashes($mod_un)."'");
				}
			}
			$DbLink->clean_results();

			// Update the current user status for the room to be created in registered users table
			$changed = false;
			if (!eregi($R2,$rooms))
			{
				if ($rooms != "") $rooms .= ",";
				$rooms .= stripslashes($R2);
				$changed = true;
			}
			if ($perms == "user")
			{
				$perms = "moderator";
				$changed = true;
			}
			if (($changed)&&($perms != "admin"))
			{
				$DbLink->query("UPDATE ".C_REG_TBL." SET perms='$perms', rooms='".addslashes($rooms)."' WHERE username='$U'");
			}
		}
	}
}


// ** Enter the chat **
if(!isset($Error) && (isset($N) && $N != ""))
{
	if(isset($R2) && $R2 != "")
	{
		$R = $R2;
	}
	elseif (!isset($R))		// $R is set when the frameset is reloaded because of the NN4+ resize bug.
	{
		$T = 1;
		$R = (isset($R0) && $R0 != "")? $R0 : $R1;
	}

	$CookieRoom = urlencode(stripslashes($R));
	setcookie("CookieRoom", $CookieRoom, time() + 60*60*24*365);        // cookie expires in one year
	setcookie("CookieRoomType", $T, time() + 60*60*24*365);        // cookie expires in one year
	if (isset($HTTP_COOKIE_VARS))
	{
		$CookieMsgOrder = $HTTP_COOKIE_VARS["CookieMsgOrder"];
		$CookieShowTimestamp = $HTTP_COOKIE_VARS["CookieShowTimestamp"];
		$CookieNotify = $HTTP_COOKIE_VARS["CookieNotify"];
	};
	if (!isset($O)) $O = isset($CookieMsgOrder) ? $CookieMsgOrder : C_MSG_ORDER;
	if (!isset($ST)) $ST = isset($CookieShowTimestamp) ? $CookieShowTimestamp : C_SHOW_TIMESTAMP;
	if (!isset($NT)) $NT = isset($CookieNotify) ? $CookieNotify : C_NOTIFY;
	if (!isset($PWD)) $PWD = md5(stripslashes($PASSWORD));
	$Latin1 = ($Charset == 'iso-8859-1');

	// Define the user status to be put in the users table if necessary. Skipped when the
	// frameset is reloaded because of the NN4+ resize bug.
	if (!isset($Reload) || $Reload != "NNResize")
	{
		if (!isset($perms)) $perms = "";
		switch ($perms)
		{
			case 'admin':
				$status = "a";
				break;
			case 'moderator':
				if (eregi($R,$rooms))
				{
					$status = "m";
					break;
				}
			default:
				$status = "";
		}
	};

	// In the case of a registered user that logs again...
	// ...in the same room update his logging time;
	// ...in an other room kick him from the other room, put a notification message of
	// 		exit for this room, update the users table and put a notification message of
	// 		entrance for the room he log in.
	if (isset($relog) && $relog)
	{
		if (stripslashes($R) == $room)
		{
			$DbLink->query("UPDATE ".C_USR_TBL." SET u_time='".time()."' WHERE username='$U'");
		}
		else
		{
			$DbLink->query("SELECT type FROM ".C_MSG_TBL." WHERE room='".addslashes($room)."' LIMIT 1");
			list($type) = $DbLink->next_record();
			$DbLink->clean_results();
			$DbLink->query("INSERT INTO ".C_MSG_TBL." VALUES ('$type', '".addslashes($room)."', '', '', ".time().", '', '/exit $U')");
			$DbLink->query("INSERT INTO ".C_MSG_TBL." VALUES ($T, '$R', '', '', ".time().", '', '/enter $U')");
			$DbLink->query("UPDATE ".C_USR_TBL." SET room='$R',u_time='".time()."', status='$status' WHERE username='$U'");
		}
	}
	// In the case of an user that logs again in the same room because of the resize bug of NN4+ 
	// update his logging time,
	elseif (isset($Reload) && $Reload == "NNResize")
	{
		$DbLink->query("UPDATE ".C_USR_TBL." SET room='$R',u_time='".time()."' WHERE username='$U'");
	}
	// For all other case of users entering in, set user infos. in users table and put a
	// notification message of entrance in the messages table
	else
	{
		$DbLink->query("INSERT INTO ".C_USR_TBL." VALUES ('$R', '$U', '$Latin1', ".time().", '$status')");
		$DbLink->query("INSERT INTO ".C_MSG_TBL." VALUES ($T, '$R', '', '', ".time().", '', '/enter $U')");
	}
	?>
	<HTML>
	<HEAD>
	<TITLE><?php echo(APP_NAME); ?></TITLE>
	<LINK REL="SHORTCUT ICON" HREF="<?php echo($ChatPath); ?>favicon.ico">
	<SCRIPT TYPE="text/javascript" LANGUAGE="JavaScript">
	<!--
	// Display & remove the server time at the status bas
	function clock(gap)
	{
		cur_date = new Date();
		calc_date = new Date(cur_date - gap);
		calc_hours = calc_date.getHours();
		calc_minuts = calc_date.getMinutes();
		calc_seconds = calc_date.getSeconds();
		if (calc_hours < 10) calc_hours = "0" + calc_hours;
		if (calc_minuts < 10) calc_minuts = "0" + calc_minuts;
		if (calc_seconds < 10) calc_seconds = "0" + calc_seconds;
		calc_time = calc_hours + ":" + calc_minuts + ":" + calc_seconds;
		window.status = "<?php echo(L_SVR_TIME); ?>" + calc_time;

		clock_disp = setTimeout('clock(' + gap + ')', 1000);
	}

	function stop_clock()
	{
		clearTimeout(clock_disp);
		window.status = '';
	}

	function calc_gap(serv_date)
	{
		server_date = new Date(serv_date);
		local_date = new Date();
		return local_date - server_date;
	}

	<?php
	if ($ST == 1)
	{
		$CorrectedDate = mktime(date("H") + C_TMZ_OFFSET,date("i"),date("s"),date("m"),date("d"),date("Y"));
		?>
		gap = calc_gap("<?php echo(date("F d, Y H:i:s", $CorrectedDate)); ?>");
		clock(gap);
		<?php
	}
	?>

	// Misc vars
	var is_ignored_popup = null;
	<?php
	if ($Ver == "H")
	{
		?>
		var isExpanded = false;
		var path2Chat = "<?php echo($ChatPath); ?>";
		<?php
	}
	?>
	// -->
	</SCRIPT>
	<?php
	if ($Ver == "H")
	{
		?>
			<SCRIPT SRC="<?php echo($ChatPath); ?>lib/usersH.js" TYPE="text/javascript" LANGUAGE="JavaScript1.2"></SCRIPT>
		<?php
	}
	$Ver1 = ($Ver == "H" ? $Ver : "L");
	?>
	</HEAD>
	<FRAMESET COLS="*,130" BORDER="0" OnResize="if (document.layers) document.location = '<?php echo("$From?L=$L&Ver=$Ver&U=".Url($U)."&PWD=$PWD&R=".Url($R)."&T=$T&D=$D&N=$N&Reload=NNResize"); ?>';">
		<FRAMESET ROWS="*,50" BORDER=0>
			<FRAME SRC="<?php echo($ChatPath); ?>messages.php3?<?php echo("From=$From&L=$L&U=".Url($U)."&R=".Url($R)."&T=$T&D=$D&N=$N&O=$O&ST=$ST&NT=$NT"); ?>" NAME="messages" MARGINWIDTH=3 MARGINHEIGHT=3>
			<FRAME SRC="<?php echo($ChatPath); ?>input.php3?<?php echo("From=$From&Ver=$Ver&L=$L&U=".Url($U)."&R=".Url($R)."&T=$T&D=$D&N=$N&O=$O&ST=$ST&NT=$NT&PWD=$PWD"); ?>" NAME="input" MARGINWIDTH=0 MARGINHEIGHT=0 SCROLLING="NO" NORESIZE>
		</FRAMESET>
		<FRAMESET ROWS="80, *,50" BORDER=0>
			<FRAME SRC="<?php echo($ChatPath); ?>exit.php3?<?php echo("From=$From&Ver=$Ver&L=$L&U=".Url($U)."&R=".Url($R)."&T=$T"); ?>" NAME="exit" MARGINWIDTH=3 MARGINHEIGHT=3 SCROLLING="NO">
			<FRAME SRC="<?php echo($ChatPath); ?>users<?php echo($Ver1); ?>.php3?<?php echo("From=$From&L=$L&U=".Url($U)."&PWD=$PWD&R=".Url($R)."&T=$T&D=$D&N=$N&O=$O&ST=$ST&NT=$NT"); ?>" NAME="users" MARGINWIDTH=3 MARGINHEIGHT=3>
			<FRAME SRC="<?php echo($ChatPath); ?>link.php3" NAME="link" MARGINWIDTH=0 MARGINHEIGHT=0 SCROLLING="NO">
		</FRAMESET>
	</FRAMESET>
	</HTML>
	<?php
	$DbLink->close();
	exit;
}
?>

<?php
// ----	The send_headers function add lines at the head part of your html file.
//		$title var allows to show "phpMyChat" as the title for your window if it set to 1/true.
//		$icon var allows to set phpMyChat icon as the icon for favorites if it set to 1/true.

function send_headers($title, $icon)
{
	global $ChatPath, $From, $L;
	global $Charset, $FontSize;

	if ($title) echo("<TITLE>".APP_NAME."</TITLE>\n");
	if ($icon) echo("<LINK REL=\"SHORTCUT ICON\" HREF=\"${ChatPath}favicon.ico\">\n");
	?>
	<LINK REL="stylesheet" HREF="<?php echo($ChatPath); ?>config/start_page.css.php3?<?php echo("Charset=${Charset}&medium=${FontSize}"); ?>" TYPE="text/css">
	<SCRIPT TYPE="text/javascript" LANGUAGE="javascript">
	<!--
	NS4 = (document.layers) ? 1 : 0;
	IE4 = ((document.all) && (parseInt(navigator.appVersion)>=4)) ? 1 : 0;
	ver4 = (NS4 || IE4) ? "H" : "L";

	// Open the users popup according to the DHTML capacities of the browser
	function users_popup()
	{
		window.open("<?php echo($ChatPath); ?>users_popup"+ver4+".php3?<?php echo("From=$From&L=$L"); ?>","users_popup_<?php echo(md5(uniqid(""))); ?>","width=180,height=300,resizable=yes,scrollbars=yes");
	}

	// Open popups for registration stuff
	function reg_popup(name)
	{
		url = "<?php echo($ChatPath); ?>" + name + ".php3?L=<?php echo($L); ?>&Link=1";
		pop_width = (name != 'admin'? 350:510);
		pop_height = (name != 'deluser'? 400:190);
		param = "width=" + pop_width + ",height=" + pop_height + ",resizable=yes,scrollbars=yes";
		name += "_popup";
		window.open(url,name,param);
	}

	// The three functions bellow allows to ensure an unique choice among rooms
	function reset_R0()
	{
		<?php
		if (C_VERSION == 2)
		{
			?>
			document.Params.R1.options[0].selected = true;
			document.Params.T.options[0].selected = true;
			document.Params.R2.value = '';
			<?php
		}
		?>
	}

	function reset_R1()
	{
		document.Params.R0.options[0].selected = true;
		document.Params.T.options[0].selected = true;
		document.Params.R2.value = '';
	}

	function reset_R2()
	{
		document.Params.R0.options[0].selected = true;
		document.Params.R1.options[0].selected = true;
	}
	// -->
	</SCRIPT>
	<?php

} // end of send_headers function;



// ----	The layout function draw the initial table/form. It will define three way to go
//		into the chat (the $Ver et $Ver1 var) dependent of the browser capacities:
//		-	those that accept DHTML will use "H" (for highest) named scripts, the others
//			will run "L" (for lowest) named scripts;
//		-	those that support JavaScript1.1 stuff will use a color picker to choose
//			messages colors in the chat/input.php3 script ($Ver is set to "M" for medium
//			if the browser can not support DHTML, else "H"), others a drop down list.

function layout($Err, $U, $R, $T)
{
	global $DbLink;
	global $ChatPath, $From, $Action, $L;
	global $AvailableLanguages;
	global $DefaultChatRooms;
	if ($Err) global $Error;
	?>

<TABLE ALIGN="center" CELLPADDING=5 CLASS="ChatBody"><TR><TD CLASS="ChatBody">

<CENTER>
<FORM ACTION="<?php echo("$Action?L=$L"); ?>" METHOD=POST NAME="Params">
<SPAN CLASS="ChatTitle"><?php echo(APP_NAME." ".APP_VERSION); ?></SPAN>
<P>
<A HREF="<?php echo($ChatPath); ?>tutorial_popup.php3?L=<?php echo($L); ?>" CLASS="ChatLink" TARGET="_blank"><?php echo(L_TUTORIAL); ?></A>
<P CLASS="ChatP1">
<?php echo(L_WEL_1." ".C_MSG_DEL." ".L_WEL_2." ".C_USR_DEL." ".L_WEL_3); ?>
</P>
<?php
$DefaultRoomFound = 0;
if($DbLink->query("SELECT DISTINCT u.username FROM ".C_USR_TBL." u, ".C_MSG_TBL." m WHERE u.room = m.room AND m.type = 1"))
{
	$Nb = $DbLink->num_rows();
	$link = " <A HREF='${ChatPath}users_popupL.php3?From=$From&L=$L' CLASS='ChatLink' onClick='users_popup(); return false' TARGET='_blank'>";
	echo("<P CLASS='ChatP1'>".L_CUR_1.$link.$Nb." ".($Nb > 1 ? L_USERS : L_USER)."</A> ".L_CUR_2."</P>");
}
if(isset($Error))
{
	echo("<P CLASS='ChatError'>$Error</P>");
}
if (!isset($Ver)) $Ver = "L";
?>

<INPUT TYPE="hidden" NAME="Ver" VALUE="<?php echo($Ver); ?>">
<INPUT TYPE="hidden" NAME="Form_Send" VALUE="1">
<INPUT TYPE="hidden" NAME="L" VALUE="<?php echo($L); ?>">
<TABLE BORDER=0 CELLPADDING=3 CLASS="ChatTable">
<TR CLASS="ChatCell">
	<TD ALIGN=CENTER CLASS="ChatCell">
		<TABLE BORDER=0 CLASS="ChatTable">
		<?php
		// Display flags if necessary
		if (C_MULTI_LANG == 1)
		{
		?>
		<TR CLASS="ChatCell">
			<TD COLSPAN=2 ALIGN=CENTER CLASS="ChatCell">
				<SPAN CLASS="ChatFlags">
				<?php
				asort($AvailableLanguages);
				reset($AvailableLanguages);
				$i = 0;
				while(list($key, $name) = each($AvailableLanguages))
				{
					$i++;
					echo("<A HREF=\"$Action?L=${name}\">");
					echo("<IMG SRC=\"${ChatPath}localization/flags/${name}.gif\" BORDER=0 WIDTH=24 HEIGHT=16 ALT=\"".str_replace("_"," ",$name)."\"></A>&nbsp;");
					if ($i == 15) echo ("<BR>");
				}
				?>
				</SPAN>
			</TD>
		</TR>
		<?php
		}
		?>
		<TR CLASS="ChatCell">
			<TH COLSPAN=2 CLASS="ChatTabTitle"><?php echo(L_SET_1); ?></TH>
		</TR>
		<TR CLASS="ChatCell">
			<TD ALIGN=RIGHT VALIGN=TOP CLASS="ChatCell" NOWRAP><?php echo(L_SET_2); ?> :</TD>
			<TD VALIGN=TOP CLASS="ChatCell">
				<INPUT TYPE=text NAME="U" SIZE=11 MAXLENGTH=10 VALUE="<?php echo(htmlspecialchars(urldecode($U))); ?>" CLASS="ChatBox">
			</TD>
		</TR>
		<TR CLASS="ChatCell">
			<TD ALIGN=RIGHT VALIGN=TOP CLASS="ChatCell" NOWRAP><?php echo(L_REG_1); ?> :</TD>
			<TD VALIGN=TOP CLASS="ChatCell">
				<INPUT TYPE=password NAME="PASSWORD" SIZE=11 MAXLENGTH=16 CLASS="ChatBox">
			</TD>
		</TR>
		<INPUT TYPE="hidden" NAME="N" VALUE="<?php echo(C_MSG_NB); ?>">
		<INPUT TYPE="hidden" NAME="D" VALUE="<?php echo(C_MSG_REFRESH); ?>">

		<TR CLASS="ChatCell"><TD CLASS="ChatCell">&nbsp;</TD></TR>

		<TR CLASS="ChatCell">
			<TH COLSPAN=2 CLASS="ChatTabTitle"><?php echo(L_REG_2); ?></TH>
		</TR>
		<TR CLASS="ChatCell">
			<TD ALIGN=center COLSPAN=2 CLASS="ChatCell">
				<BR>
				<A HREF="<?php echo($ChatPath); ?>register.php3?L=<?php echo($L); ?>" CLASS="ChatReg" onClick="reg_popup('register'); return false" TARGET="_blank"><?php echo(L_REG_3); ?></A>
				| <A HREF="<?php echo($ChatPath); ?>edituser.php3?L=<?php echo($L); ?>" CLASS="ChatReg" onClick="reg_popup('edituser'); return false" TARGET="_blank"><?php echo(L_REG_4); ?></A>
				<?php
				if (C_SHOW_DEL_PROF != 0)
				{
					?>
					| <A HREF="<?php echo($ChatPath); ?>deluser.php3?L=<?php echo($L); ?>" CLASS="ChatReg" onClick="reg_popup('deluser'); return false" TARGET="_blank"><?php echo(L_REG_5); ?></A>
					<?php
				}
				if (C_SHOW_ADMIN != 0)
				{
					?>
					|| <A HREF="<?php echo($ChatPath); ?>admin.php3?L=<?php echo($L); ?>&Link=1" CLASS="ChatReg" onClick="reg_popup('admin'); return false" TARGET="_blank"><?php echo(L_REG_35); ?></A>
					<?php
				}
				?>
			</TD>
		</TR>
		<?php
		if (C_VERSION > 0)
		{
			?>
			<TR CLASS="ChatCell">
				<TD COLSPAN=2 CLASS="ChatCell">&nbsp;</TD>
			</TR>
			<TR CLASS="ChatCell">
				<TH COLSPAN=2 CLASS="ChatTabTitle"><?php echo(L_SET_5); ?></TH>
			</TR>
			</TABLE>
			<TABLE BORDER=0 CLASS="ChatTable">
			<TR CLASS="ChatCell">
				<TD ALIGN=RIGHT VALIGN=TOP CLASS="ChatCell" NOWRAP><?php echo(L_SET_6); ?> :</TD>
				<TD VALIGN=TOP CLASS="ChatCell">
					<SELECT NAME="R0" CLASS="ChatBox" onChange="javascript:reset_R0();">
						<OPTION VALUE=""><?php echo(L_SET_7); ?></OPTION>
						<?php
						// Display default rooms in the drop down list
						$PrevRoom = "";
						if($R != "") $PrevRoom = urldecode($R);

						$DefaultRoomsString = "#";
						for($i = 0; $i < count($DefaultChatRooms); $i++)
						{
							$tmpRoom = stripslashes($DefaultChatRooms[$i]);
							$DefaultRoomsString .= $tmpRoom."#";
							echo("<OPTION VALUE=\"".htmlspecialchars($tmpRoom)."\"");
							if(strcasecmp($tmpRoom, $PrevRoom) == 0)
							{
								echo(" SELECTED");
								$DefaultRoomFound = 1;
							}
							echo(">".$tmpRoom."</OPTION>");
						}
						?>
					</SELECT>
				</TD>
			</TR>
			<?php
		}
		if (C_VERSION == 2)
		{
			?>
			<TR CLASS="ChatCell">
				<TD ALIGN=RIGHT VALIGN=TOP CLASS="ChatCell" NOWRAP><?php echo(L_SET_8); ?> :</TD>
				<TD VALIGN=TOP CLASS="ChatCell">
					<SELECT NAME="R1" CLASS="ChatBox" onChange="javascript:reset_R1();">
						<OPTION VALUE=""><?php echo(L_SET_7); ?></OPTION>
						<?php
						// Display other public rooms in the drop down list
						$DbLink->query("SELECT DISTINCT room FROM ".C_MSG_TBL." WHERE type = 1 AND username != '' ORDER BY room");
						while(list($Room) = $DbLink->next_record())
						{
							if(!eregi("#${Room}#", $DefaultRoomsString))
							{
								echo("<OPTION VALUE=\"".htmlspecialchars($Room)."\"");
								if(strcasecmp($Room, $PrevRoom) == 0 && $DefaultRoomFound == 0)
								{
									echo(" SELECTED");
									$DefaultRoomFound = 1;
								}
								echo(">${Room}</OPTION>");
							}
						}
						?>
					</SELECT>
				</TD>
			</TR>
			<TR CLASS="ChatCell">
				<TD ALIGN=RIGHT VALIGN=TOP CLASS="ChatCell" NOWRAP>
					<?php echo(L_SET_9." "); ?>
					<SELECT NAME="T" CLASS="ChatBox">
						<OPTION VALUE="1" <?php if($T == 1 && $DefaultRoomFound == 0) echo("SELECTED"); ?>><?php echo(L_SET_10); ?></OPTION>
						<OPTION VALUE="0" <?php if($T == 0 && $DefaultRoomFound == 0) echo("SELECTED"); ?>><?php echo(L_SET_11); ?></OPTION>
					</SELECT>
					<?php echo(" ".L_SET_12); ?> :
				</TD>
				<TD VALIGN=TOP CLASS="ChatCell">
					<INPUT TYPE="text" NAME="R2" SIZE=11 MAXLENGTH=10 <?php if($DefaultRoomFound == 0 && $R != "") echo("VALUE=\"".htmlspecialchars(urldecode($R))."\""); ?> CLASS="ChatBox" onChange="javascript:reset_R2();">
				</TD>
			</TR>
			<?php
		}
		?>
		</TABLE>
		<P CLASS="ChatP2">
		<?php echo(L_SET_13." "); ?>
		<INPUT TYPE="submit" VALUE="<?php echo(L_SET_14); ?>" CLASS="ChatBox"> ...
		</P>
	</TD>
</TR>
</TABLE>
<SPAN CLASS="ChatCopy">
&copy; 2000 <A HREF="http://www.phpheaven.net/" CLASS="ChatLink">The phpHeaven Team</A> -
<?php echo(APP_NAME." ".L_SRC." "); ?>
<A HREF="http://www.phpheaven.net/" CLASS="ChatLink">phpHeaven</A>
</SPAN>
</FORM>
</CENTER>

</TD></TR></TABLE>

<!-- Define version of chat to use depending on js1.1 and DHTML availabilities -->
<SCRIPT TYPE="text/javascript" LANGUAGE="javascript">
<!--
document.Params.Ver.value = ver4;
// -->
</SCRIPT>
<SCRIPT TYPE="text/javascript" LANGUAGE="javascript1.1">
<!--
if (document.Params.Ver == "L") document.Params.Ver.value = "M";
// -->
</SCRIPT>

<?php
} // end of the layout function
?>