<?php
// Get the names and values for vars sended by the script that called this one
if (isset($HTTP_GET_VARS))
{
	while(list($name,$value) = each($HTTP_GET_VARS))
	{
		$$name = $value;
	};
};

require("config/config.lib.php3");
require("localization/".$L.".lang.php3");
require("lib/release.lib.php3");
require("lib/database/".C_DB_TYPE.".lib.php3");
require("lib/clean.lib.php3");

header("Expires: Sun, 28 Dec 1997 09:32:45 GMT");
header("Cache-Control: no-cache, must-revalidate");
header("Pragma: no-cache");
header("Content-Type: text/html; charset=${Charset}");

$DbLink = new DB;


// ** Check for user entrance to beep **
// Initialize some vars if necessary and put beep on/off in a cookie
if (isset($HTTP_COOKIE_VARS["CookieBeep"])) $CookieBeep = $HTTP_COOKIE_VARS["CookieBeep"];
if (!isset($B)) $B = (isset($CookieBeep) ? $CookieBeep : "1");
setcookie("CookieBeep", $B, time() + 60*60*24*365);		// cookie expires in one year
$BeepRoom = "0";
if (!isset($LastCheck) || $B == "0") $LastCheck = time();

if ($B > 0)
{
	$DbLink->query("SELECT DISTINCT m_time, message FROM ".C_MSG_TBL." WHERE m_time > '$LastCheck' AND username = '' AND type = 1 ORDER BY m_time DESC");
	if ($DbLink->num_rows() > 0)
	{
		while(list($Time, $Message) = $DbLink->next_record())
		{
			if (ereg("^/enter",$Message)) $BeepRoom = "1";
			if ($Time > $LastCheck) $LastCheck = $Time;
			if ($BeepRoom) break;
		}
	}
	$DbLink->clean_results();
}

// ** Set the http refresh header **
$URL_Query = getenv("QUERY_STRING");
if (!ereg("LastCheck", $URL_Query))
{
	$Refresh = $URL_Query."&LastCheck=${LastCheck}&B=${B}";
}
else
{
	$Refresh = ereg_replace("LastCheck=([0-9]+)","LastCheck=".$LastCheck, $URL_Query);
}
header("Refresh: 30; URL=users_popupH.php3?${Refresh}");

// ** Compute the beeps/nobeeps reload query used when the sound icon is clicked **
$B1 =  ($B > 0 ? "0" : "1");
$ChangeBeeps_Reload = ereg_replace("&B=([0-2])","&B=${B1}",$Refresh);
?>
<HTML>

<HEAD>
<?php
function special_char($str,$lang,$type)
{
	$tag_open = (($type == 'a' || $type == 'm') ? "<I>":"");
	$tag_close = ($tag_open != "" ? "</I>":"");
	return $tag_open.($lang ? htmlentities($str) : htmlspecialchars($str)).$tag_close;
}

// ** count rooms **
$DbLink->query("SELECT DISTINCT u.room FROM ".C_USR_TBL." u, ".C_MSG_TBL." m WHERE u.room = m.room AND m.type = 1");
$NbRooms = $DbLink->num_rows();
$DbLink->clean_results();

if ($NbRooms > 0)
{
	// ** count users **
	$DbLink->query("SELECT DISTINCT u.username, u.latin1 FROM ".C_USR_TBL." u, ".C_MSG_TBL." m WHERE u.room = m.room AND m.type = 1 ORDER BY u.username");
	$NbUsers = $DbLink->num_rows();
	if($NbUsers > 3)
	{
		echo("<TITLE>".$NbUsers." ".($NbUsers > 1 ? L_USERS : L_USER)."/".$NbRooms." ".($NbRooms > 1 ? L_ROOMS : L_ROOM)."</TITLE>");
	}
	else
	{
		echo("<TITLE>");
		$Term = "";
		while(list($Username,$Latin1) = $DbLink->next_record())
		{
			echo($Term.special_char($Username,$Latin1,''));
			$Term = ", ";
		}
		echo("</TITLE>");
	};
	$DbLink->clean_results();
}
else
{
	echo("<TITLE>".L_NO_USER."</TITLE>");
};
?>
<LINK REL="stylesheet" HREF="config/style.css.php3?<?php echo("Charset=${Charset}&medium=${FontSize}"); ?>" TYPE="text/css">

<!-- Collapsible rooms scripts -->
<SCRIPT TYPE="text/javascript" LANGUAGE="JavaScript1.2">
<!--
NS4 = (document.layers) ? 1 : 0;
IE4 = ((document.all) && (parseInt(navigator.appVersion)>=4)) ? 1 : 0;
ver4 = (NS4 || IE4) ? 1 : 0;
//-->
</SCRIPT>
<SCRIPT SRC="lib/users_popupH.js" TYPE="text/javascript" LANGUAGE="JavaScript1.2"></SCRIPT>
</HEAD>

<BODY CLASS=frame onClick="self.focus();">
<CENTER>
	<A HREF="<?php echo("$From?Ver=H&L=$L"); ?>" TARGET="_blank"><?php echo(L_CHAT); ?></A>
	<P>
		<A HREF="#" onClick="expandAll(); return false">
		<IMG NAME="imEx_big" SRC="images/closed_big.gif" WIDTH=13 HEIGHT=13 ALIGN=MIDDLE BORDER=0 ALT="<?php echo(L_EXPCOL_ALL); ?>"></A>
		&nbsp;
		<A HREF="users_popupH.php3?<?php echo($ChangeBeeps_Reload); ?>"><IMG SRC="images/<?php if ($B == "0") echo("no"); ?>sound.gif" WIDTH=13 HEIGHT=13 ALIGN=MIDDLE BORDER=0 ALT="<?php echo(L_BEEP); ?>"></A>
	</P>
</CENTER>

<P>
<?php

//** Build users list **
$Users = new DB;
if($NbUsers > 0)
{
	if($DbLink->query("SELECT DISTINCT room FROM ".C_MSG_TBL." WHERE type = 1 ORDER BY room"))
	{
		if($DbLink->num_rows() > 0)
		{
			$i = 0;
			while(list($Other) = $DbLink->next_record())
			{
				if($Users->query("SELECT username, latin1, status FROM ".C_USR_TBL." WHERE room = '".addslashes($Other)."' ORDER BY username"))
				{
					if($Users->num_rows() > 0)
					{
						$i++;
						echo("<DIV ID=\"room".$i."Parent\" CLASS=\"parent\" STYLE=\"margin-top: 5px; CURSOR: hand\">");
						echo("<A HREF=\"#\" onClick=\"expandIt('room".$i."'); return false\">");
						echo("<IMG NAME=\"imEx\" SRC=\"images/closed.gif\" WIDTH=12 HEIGHT=9 BORDER=0 ALT=\"".L_EXPCOL."\"></A>");
						echo("<B>".htmlspecialchars($Other)."</B><SPAN CLASS=small>&nbsp;(".$Users->num_rows().")</SPAN><BR>");
						echo("</DIV>");
						echo("<DIV ID=\"room".$i."Child\" CLASS=\"child\" STYLE=\"margin-left: 12px\">");
						while(list($Username,$Latin1,$status) = $Users->next_record())
						{
							echo("-&nbsp;".special_char($Username,$Latin1,$status)."<BR>");
						}
						echo("</DIV>");
					}
				}
				$Users->clean_results();
			}
		}
	}
	$DbLink->clean_results();
}
else
{
	echo("<CENTER>".L_NO_USER."</CENTER>");
}
?>
</P>

<SCRIPT TYPE="text/javascript" LANGUAGE="JavaScript1.2">
<!--
// Get the index of the first expandable/collapsible room under NN4+
if (NS4)
{
	<?php
	if ($NbRooms > 0)
	{
		?>
		firstEl = "room1Parent";
		firstInd = getIndex(firstEl);
		arrange();
		<?php
	}
	else
	{
		?>
		firstInd = null;
		<?php
	}
	?>
}
//-->
</SCRIPT>

<?php
// ** Beeps if necessary **
if ($BeepRoom)
{
	?>
	<!-- Sound for user entrance -->
	<EMBED SRC="images/beep.wav" HIDDEN="true" AUTOSTART="true" LOOP="false" NAME="Beep" MASTERSOUND>
		<NOEMBED><BGSOUND SRC="images/beep.wav" LOOP=1></NOEMBED>
	</EMBED>
	<?php
}
?>
</BODY>

</HTML>
<?php
$DbLink->close();
?>
