<?php

if (C_BAD_WORDS == 1) include("lib/swearing.lib.php3");

$new_room_type = ($Cmd[2] != "" ? $Cmd[2]:1);
$new_room = $Cmd[3];

if (C_VERSION == 1)
{
	// Ensure that the room to enter in is among default ones
	for ($i = 0; $i < count($DefaultChatRooms); $i++)
	{
		if (strcasecmp($new_room, $DefaultChatRooms[$i]) == 0) $IsCommand = true;
	}
	if (!$IsCommand) $Error = L_ERR_USR_17;
}
// Check for invalid characters
elseif (ereg("[\,]", stripslashes($new_room)))
{
	$Error = L_ERR_ROM_1;
}
// Check for bad words if necessary
else if(C_BAD_WORDS == 1 && checkwords($new_room, true))
{
	$Error = L_ERR_ROM_2;
}
else
{
	$IsCommand = true;
}
	
if ($IsCommand)
{
	$what_room = "";

	// Get the type of the room
	if ($new_room_type == "1")
	{
		for ($i = 0; $i < count($DefaultChatRooms); $i++)
		{
			if (strcasecmp($new_room, $DefaultChatRooms[$i]) == 0)
			{
				$what_room = "R0";
				$new_room = $DefaultChatRooms[$i];
			}
		}
		if ($what_room == "")
		{
			$DbLink->query("SELECT room FROM ".C_MSG_TBL." WHERE type=1 AND room='".$new_room."' LIMIT 1");
			if ($DbLink->num_rows() != 0)
			{
				$what_room = "R1";
				list($new_room) = $DbLink->next_record();
			}
			$DbLink->clean_results();
		}
	}
	// Room must be created
	if ($what_room == "")
	{
		// If user wants to create a private room, ensure its name does not match one of the
		// default rooms name
		if ($new_room_type == "0")
		{
			for ($i = 0; $i < count($DefaultChatRooms); $i++)
			{
				if (strcasecmp($new_room, $DefaultChatRooms[$i]) == 0) $Error = L_ERR_ROM_3;
			}
		}

		// Ensure the user is a registered one
		if (!isset($Error))
		{
			$DbLink->query("SELECT count(*) FROM ".C_REG_TBL." WHERE username='$U'");
			list($count) = $DbLink->next_record();
			if ($count != 0) $what_room = "R2";
			$DbLink->clean_results();
		}

		// Ensure an existing room with a different type does not exist
		if ($what_room == "R2")
		{
			$T1 = 1 - $new_room_type;
			$DbLink->query("SELECT count(*) FROM ".C_MSG_TBL." WHERE room = '".$new_room."' AND type = '$T1' LIMIT 1");
			list($count) = $DbLink->next_record();
			$DbLink->clean_results();
			if($count != 0)
			{
				$Error = ($new_room_type == 0 ? L_ERR_ROM_3:L_ERR_ROM_4);
				$what_room = "";
			}
		}
	}

	// If the room can't be created
	if ($what_room == "")
	{
		if (!isset($Error)) $Error = L_ERR_USR_13;
		$IsCommand = false;
	}
	// Log into the new room
	else
	{
		$DbLink->query("INSERT INTO ".C_MSG_TBL." VALUES ($T, '$R', '', '', ".time().", '', '/exit $U')");
		$DbLink->query("DELETE FROM ".C_USR_TBL." WHERE username='$U' AND room='$R'");
		?>
		<SCRIPT TYPE="text/javascript" LANGUAGE="JavaScript">
		<!--
		parent.location = '<?php echo("$From?Ver=$Ver&L=$L&U=".urlencode(stripslashes($U))."&$what_room=".urlencode(stripslashes($new_room))."&D=$D&N=$N&O=$O&ST=$ST&NT=$NT&E=".urlencode(stripslashes($R))."&T=$new_room_type&Reload=JoinCmd");  if (isset($PWD)) echo("&PWD=".urlencode(stripslashes($PWD))); ?>';
		// -->
		</SCRIPT>
		<?php
		exit;
	}
}

?>