<?php
// Get the names and values for vars sended by index.lib.php3
if (isset($HTTP_GET_VARS))
{
	while(list($name,$value) = each($HTTP_GET_VARS))
	{
		$$name = $value;
	};
};

require("config/config.lib.php3");
require("localization/".$L.".lang.php3");
require("lib/database/".C_DB_TYPE.".lib.php3");
require("lib/clean.lib.php3");

header("Expires: Sun, 28 Dec 1997 09:32:45 GMT");
header("Cache-Control: no-cache, must-revalidate");
header("Pragma: no-cache");
if ($D > 0 && !C_USE_PERSISTENT) header("Refresh: ${D}; URL=messages.php3?".getenv("QUERY_STRING"));

header("Content-Type: text/html; charset=${Charset}");

// Avoid server configuration for magic quotes and remove the php max execution time setting
// if persistent connection mode
set_magic_quotes_runtime(0);
if (C_USE_PERSISTENT) set_time_limit(0);


// Translate to html special characters, and entities if message was sent with a latin 1 charset
$Latin1 = ($Charset == "iso-8859-1");
function special_char($str,$lang)
{
	return ($lang ? htmlentities(stripslashes($str)) : htmlspecialchars(stripslashes($str)));
}


// ** Updates user info in connected users tables **
function update_user_info()
{
	global $DbLink, $From, $R, $U, $T, $L, $Latin1;

	$DbLink->query("SELECT status,room FROM ".C_USR_TBL." WHERE username = '$U' LIMIT 1");
	if($DbLink->num_rows() != 0)
	{
		// There is a row for the user in the users table
		list($status,$room) = $DbLink->next_record();
		$DbLink->clean_results();
		$kicked = 0;
		if ($room != stripslashes($R))	// Same nick in another room
		{
			$DbLink->query("INSERT INTO ".C_MSG_TBL." VALUES ($T, '$R', '', '', ".time().", '', '/exit $U')");
			$kicked = 3;
		}
		elseif ($status == "k")			// Kicked by a moderator or the admin.
		{
			$DbLink->query("INSERT INTO ".C_MSG_TBL." VALUES ($T, '$R', '', '', ".time().", '', '/exit $U')");
			$kicked = 1;
		}
		elseif ($status == "d")			// The admin just deleted the room
		{
			$kicked = 2;
		}
		if ($kicked > 0)
		{
			// Kick the user from the current room
			?>
			<SCRIPT TYPE="text/javascript" LANGUAGE="JavaScript">
			<!--
			parent.location = '<?php echo("$From?L=$L&U=".urlencode(stripslashes($U))."&E=$R&KICKED=${kicked}"); ?>';
			// -->
			</SCRIPT>
			<?php
			$DbLink->close();
			exit;
		}
		// Updates the time to ensure the user won't be cleaned from the users table
		$DbLink->query("UPDATE ".C_USR_TBL." SET u_time = ".time()." WHERE room = '$R' AND username = '$U'");
	}
	else
	{
		// User hasn't been found in the users table -> add a row
		$DbLink->clean_results();
		$DbLink->query("SELECT perms,rooms FROM ".C_REG_TBL." WHERE username='$U' LIMIT 1");
		$reguser = ($DbLink->num_rows() != 0);
		if ($reguser) list($perms, $rooms) = $DbLink->next_record();
		$DbLink->clean_results();
		// Get user status
		$status = "";
		if ($reguser)
		{
			switch ($perms)
			{
				case 'admin':
					$status = "a";
					break;
				case 'moderator':
					if (eregi(stripslashes($R),$rooms)) $status = "m";
			}
		}
		$DbLink->query("INSERT INTO ".C_USR_TBL." VALUES ('$R', '$U', '$Latin1', ".time().", '$status')");
	}
}

$DbLink = new DB;
update_user_info();
?>
<HTML>

<HEAD>
<LINK REL="stylesheet" HREF="config/style.css.php3?<?php echo("Charset=${Charset}&medium=${FontSize}"); ?>" TYPE="text/css">
</HEAD>

<BODY CLASS="mainframe" <?php if($O == 1 && !C_USE_PERSISTENT) echo("onLoad=\"this.scrollTo(0,65000);\""); ?>>
<?php

// ** Get messages **

// Define the SQL query (depends on values for ignored users list and on whether to display
// notification messages or not
$CondForQuery = "";
if (isset($Ign))
{
	$IgnoreList = "'".str_replace(",","','",addslashes(urldecode($Ign)))."'";
	$CondForQuery = " AND username NOT IN (${IgnoreList})";
}
if ($NT == 0)
{
	$CondForQuery .= " AND username !=''";
}

$DbLink->query("SELECT m_time, username, latin1, address, message FROM ".C_MSG_TBL." WHERE room LIKE '$R' AND (address IN ('','$U') OR username = '$U')".$CondForQuery." ORDER BY m_time DESC LIMIT $N");
if (C_USE_PERSISTENT) $last_time = 0;

// Format and display new messages
if($DbLink->num_rows() > 0)
{
	$MessagesString = "";
	while(list($Time, $User, $Latin1, $Dest, $Message) = $DbLink->next_record())
	{
		if ($Dest != "") $Dest = "]>[".$Dest;
		$NewMsg = "<P CLASS=msg>";
		if ($ST == 1) $NewMsg .= "<SPAN CLASS=time>".date("H:i:s", $Time +  C_TMZ_OFFSET*60*60)."</SPAN> ";
		$User = special_char($User,$Latin1);
		$Dest = htmlspecialchars(stripslashes($Dest));
		if (ereg("^/(enter|exit)[[:space:]](.+)$",$Message,$Regs))
		{
			$Message = sprintf(($Regs[1] == "enter" ? L_ENTER_ROM : L_EXIT_ROM), $Regs[2]);
		}
		elseif (ereg("^/promote[[:space:]](.+)$",$Message,$Regs))
		{
			$Message = "<SPAN CLASS=notify>".sprintf(L_MODERATOR, $Regs[1])."</SPAN>";
		}
		elseif ($Message == "/delete")
		{
			$Message = "<SPAN CLASS=notify>".L_REG_21."</SPAN>";
		};
		$NewMsg .= ($User != '' ? "<B>[${User}${Dest}]</B> $Message</P>" : " <SPAN CLASS=notify>$Message</SPAN></P>");
		if($O == 0 && !C_USE_PERSISTENT) {
			$MessagesString .= $NewMsg;
		} else {
			$MessagesString = $NewMsg.$MessagesString;
		}
		if (C_USE_PERSISTENT && $last_time == 0) $last_time = $Time;
	}
	echo($MessagesString);
}
else
{
	echo("<SPAN CLASS=notify>".L_NO_MSG."</SPAN>");
}


// ** For persistent connection: get new messages, format and display them **
if (C_USE_PERSISTENT)
{
	$keepalive_mult = 20 / C_PERSISTENT_REFRESH;
	echo("\n<SCRIPT TYPE=\"text/javascript\" LANGUAGE=\"javascript\">\n<!--\nwindow.scrollBy(0, 65000);\n// -->\n</SCRIPT>\n");
	flush();
	echo("<SCRIPT TYPE=\"text/javascript\" LANGUAGE=\"javascript\">\n<!--\nwindow.scrollBy(0, 65000);\n// -->\n</SCRIPT>\n");
	flush();

	$counter = 0;

	while (1)
	{
		sleep(C_PERSISTENT_REFRESH);
		$DbLink->query("SELECT m_time, username, latin1, address, message FROM ".C_MSG_TBL." WHERE room LIKE '$R' AND (address IN ('','$U') OR username = '$U')".$CondForQuery." AND m_time > $last_time ORDER BY m_time");
		while(list($Time, $User, $Latin1, $Dest, $Message) = $DbLink->next_record())
		{
			if ($Dest != "") $Dest = "]>[".$Dest;
			$NewMsg = "<P CLASS=msg>";
			if ($ST == 1) $NewMsg .= "<SPAN CLASS=time>".date("H:i:s", $Time +  C_TMZ_OFFSET*60*60)."</SPAN> ";
			$User = special_char($User,$Latin1);
			$Dest = htmlspecialchars(stripslashes($Dest));
			if (ereg("^/(enter|exit)[[:space:]](.+)$",$Message,$Regs))
			{
				$Message = sprintf(($Regs[1] == "enter" ? L_ENTER_ROM : L_EXIT_ROM), $Regs[2]);
			}
			elseif (ereg("^/promote[[:space:]](.+)$",$Message,$Regs))
			{
				$Message = "<SPAN CLASS=notify>".sprintf(L_MODERATOR, $Regs[1])."</SPAN>";
			}
			elseif ($Message == "/delete")
			{
				$Message = "<SPAN CLASS=notify>".L_REG_21."</SPAN>";
			};
			$NewMsg .= ($User != '' ? "<B>[${User}${Dest}]</B> $Message</P>" : " <SPAN CLASS=notify>$Message</SPAN></P>");
			echo($NewMsg);
			$last_time = $Time;
			echo("\n<SCRIPT TYPE=\"text/javascript\" LANGUAGE=\"javascript\">\n<!--\nwindow.scrollBy(0, 16000);\n// -->\n</SCRIPT>\n");
			flush();
			echo("<SCRIPT TYPE=\"text/javascript\" LANGUAGE=\"javascript\">\n<!--\nwindow.scrollBy(0, 16000);\n// -->\n</SCRIPT>\n");
			flush();
		}

		$counter++;
		if ($counter >= $keepalive_mult)
		{
			echo("<!-- -->\n");
			flush();
			$counter = 0;
			update_user_info();
		}
	}
}

$DbLink->clean_results();
$DbLink->close();
?>
</BODY>

</HTML>