<?php
// Get the names and values for vars sended by index.lib.php3
if (isset($HTTP_GET_VARS))
{
	while(list($name,$value) = each($HTTP_GET_VARS))
	{
		$$name = $value;
	};
};

require("config/config.lib.php3");
require("localization/languages.lib.php3");
require("localization/".$L.".lang.php3");
require("lib/release.lib.php3");
require("lib/database/".C_DB_TYPE.".lib.php3");

header("Expires: Sun, 28 Dec 1997 09:32:45 GMT");
header("Cache-Control: no-cache, must-revalidate");
header("Pragma: no-cache");
header("Content-Type: text/html; charset=${Charset}");

$DbLink = new DB;

// avoid server configuration for magic quotes
set_magic_quotes_runtime(0);

// Get the names and values for post vars
if (isset($HTTP_POST_VARS))
{
	while(list($name,$value) = each($HTTP_POST_VARS))
	{
		$$name = $value;
	};
};

// Check for valid entries
if (isset($HTTP_POST_VARS))
{
	if (C_BAD_WORDS == 1) include("lib/swearing.lib.php3");
	if (trim($U) == "")
	{
		$Error = L_ERR_USR_5;
	}
	else if (ereg("[\, ]", stripslashes($U)))
	{
		$Error = L_ERR_USR_16;
	}
	else if(C_BAD_WORDS == 1 && checkwords($U, true))
	{
		$Error = L_ERR_USR_18;
	}
	else if ($PASSWORD == "")
	{
		$Error = L_ERR_USR_6;
	}
	else if (trim($FIRSTNAME) == "" || trim($LASTNAME) == "")
	{
		$Error = L_ERR_USR_15;
	}
	else if (trim($EMAIL) == "")
	{
		$Error = L_ERR_USR_7;
	}
	else if (!eregi("(([a-z0-9_]|\\-|\\.)+@([^[:space:]]*)([[:alnum:]-])\.([^[:space:]]*)([[:alnum:]-]))", $EMAIL))
	{
		$Error = L_ERR_USR_8;
	}
	else
	{
		$DbLink->query("SELECT count(*) FROM ".C_REG_TBL." WHERE username='$U'");
		list($rows) = $DbLink->next_record();
		$DbLink->clean_results();
		if ($rows != 0)
		{
			$Error = L_ERR_USR_9;
		}
		else
		{
			$Latin1 = ($Charset == "iso-8859-1");
			$pwd = md5(stripslashes($PASSWORD));
			$showemail = (isset($SHOWEMAIL) && $SHOWEMAIL)? 1:0;
			$WEBSITE = str_replace("http://","",$WEBSITE);
			$DbLink->query("INSERT INTO ".C_REG_TBL." VALUES ('$U', '$Latin1', '$pwd', '$FIRSTNAME', '$LASTNAME', '$COUNTRY', '$WEBSITE', '$EMAIL', $showemail, 'user', '',".time().")");
			$Message = L_REG_9;
		}
	}
}

// Registration has been done ?
$done = (isset($Message) && $Message == L_REG_9);
?>
<HTML>

<HEAD>
<TITLE><?php echo(APP_NAME); ?></TITLE>
<LINK REL="stylesheet" HREF="config/style.css.php3?<?php echo("Charset=${Charset}&medium=${FontSize}"); ?>" TYPE="text/css">
<SCRIPT TYPE="text/javascript" LANGUAGE="javascript">
<!--
// Insert login and password in fields of the starter page form
function LoginToIndex()
{
<?php
if (isset($Message))
{
	?>
	var indexform = window.opener.document.Params;
	var regform = document.Params;
	indexform.U.value = regform.U.value;
	indexform.PASSWORD.value = regform.PASSWORD.value;
	<?php
}
?>
}

// Put focus to the username field of the form at the starter page
function get_focus()
{
	window.focus();
	document.Params.U.focus();
}
// -->
</SCRIPT>
</HEAD>

<BODY onLoad="if (window.focus) get_focus();">
<CENTER>
<BR>
<FORM ACTION="register.php3?L=<?php echo($L); ?>" METHOD=POST NAME="Params">
<P></P>
<?php
if(isset($Error))
{
	echo("<P><SPAN CLASS=error>$Error</SPAN></P>");
}
?>
<INPUT TYPE="hidden" NAME="L" VALUE="<?php echo($L); ?>">
<TABLE BORDER=0 CELLPADDING=3 CLASS=table>
<TR>
	<TD ALIGN=CENTER>
		<TABLE BORDER=0>
		<TR>
			<TH COLSPAN=2 CLASS=tabtitle><?php if (!isset($Message)) echo(L_REG_6); else echo($Message); ?></TH>
		</TR>
		<TR>
			<TH COLSPAN=2><?php echo(L_REG_37); ?></TH>
		</TR>
		<TR><TD>&nbsp;</TD></TR>
		<TR>
			<TD ALIGN=RIGHT VALIGN=TOP NOWRAP><?php echo(L_SET_2); ?> :</TD>
			<TD VALIGN=TOP>
				<INPUT TYPE=text NAME="U" SIZE=11 MAXLENGTH=10 VALUE="<?php if (isset($U)) echo(htmlspecialchars(stripslashes($U))); ?>"<?php if ($done) echo(" READONLY"); ?>>
				<SPAN CLASS=error>*</SPAN>
			</TD>
		</TR>
		<TR>
			<TD ALIGN=RIGHT VALIGN=TOP NOWRAP><?php echo(L_REG_7); ?> :</TD>
			<TD VALIGN=TOP>
				<INPUT TYPE=password NAME="PASSWORD" SIZE=11 MAXLENGTH=16 VALUE="<?php if (isset($PASSWORD)) echo(htmlspecialchars(stripslashes($PASSWORD))); ?>"<?php if ($done) echo(" READONLY"); ?>>
				<SPAN CLASS=error>*</SPAN>
			</TD>
		</TR>
		<TR>
			<TD ALIGN=RIGHT VALIGN=TOP NOWRAP><?php echo(L_REG_30); ?> :</TD>
			<TD VALIGN=TOP>
				<INPUT TYPE=text NAME="FIRSTNAME" SIZE=11 MAXLENGTH=64 VALUE="<?php if (isset($FIRSTNAME)) echo(htmlspecialchars(stripslashes($FIRSTNAME))); ?>"<?php if ($done) echo(" READONLY"); ?>>
				<SPAN CLASS=error>*</SPAN>
			</TD>
		</TR>
		<TR>
			<TD ALIGN=RIGHT VALIGN=TOP NOWRAP><?php echo(L_REG_31); ?> :</TD>
			<TD VALIGN=TOP>
				<INPUT TYPE=text NAME="LASTNAME" SIZE=11 MAXLENGTH=64 VALUE="<?php if (isset($LASTNAME)) echo(htmlspecialchars(stripslashes($LASTNAME))); ?>"<?php if ($done) echo(" READONLY"); ?>>
				<SPAN CLASS=error>*</SPAN>
			</TD>
		</TR>
		<TR>
			<TD ALIGN=RIGHT VALIGN=TOP NOWRAP><?php echo(L_REG_36); ?> :</TD>
			<TD VALIGN=TOP>
				<INPUT TYPE=text NAME="COUNTRY" SIZE=11 MAXLENGTH=64 VALUE="<?php if (isset($COUNTRY)) echo(htmlspecialchars(stripslashes($COUNTRY))); ?>"<?php if ($done) echo(" READONLY"); ?>>
			</TD>
		</TR>
		<TR>
			<TD ALIGN=RIGHT VALIGN=TOP NOWRAP><?php echo(L_REG_32); ?> :</TD>
			<TD VALIGN=TOP>
				<INPUT TYPE=text NAME="WEBSITE" SIZE=11 MAXLENGTH=64 VALUE="<?php if (isset($WEBSITE)) echo(htmlspecialchars(stripslashes($WEBSITE))); ?>"<?php if ($done) echo(" READONLY"); ?>>
			</TD>
		</TR>
		<TR>
			<TD ALIGN=RIGHT VALIGN=TOP NOWRAP><?php echo(L_REG_8); ?> :</TD>
			<TD VALIGN=TOP>
				<INPUT TYPE=text NAME="EMAIL" SIZE=11 MAXLENGTH=64 VALUE="<?php if (isset($EMAIL)) echo(htmlspecialchars(stripslashes($EMAIL))); ?>"<?php if ($done) echo(" READONLY"); ?>>
				<SPAN CLASS=error>*</SPAN>
			</TD>
		</TR>
		<TR>
			<TD COLSPAN=2 ALIGN=center>
				<INPUT type=checkbox name="SHOWEMAIL" value="1" <?php if (isset($SHOWEMAIL) && $SHOWEMAIL) echo("CHECKED"); ?><?php if ($done) echo(" READONLY"); ?>>
				&nbsp;<?php echo(L_REG_33); ?>
			</TD>
		</TR>
		</TABLE>
		<P>
		<?php
		if (!isset($Message))
		{
			?>
			<INPUT TYPE="submit" VALUE="<?php echo(L_REG_3); ?>">
			<?php
		}
		?>
		<INPUT TYPE="submit" VALUE="<?php echo(L_REG_25); ?>" onClick="LoginToIndex(); self.close(); return false;">
	</TD>
</TR>
</TABLE>
</FORM>
</CENTER>
</BODY>

</HTML>
<?php
$DbLink->close();
?>