<?php
// Get the names and values for vars sended by input.php3
if (isset($HTTP_GET_VARS))
{
	while(list($name,$value) = each($HTTP_GET_VARS))
	{
		$$name = $value;
	};
};

require("config/config.lib.php3");
require("localization/".$L.".lang.php3");
require("lib/release.lib.php3");
require("lib/database/".C_DB_TYPE.".lib.php3");
require("lib/clean.lib.php3");

header("Expires: Sun, 28 Dec 1997 09:32:45 GMT");
header("Cache-Control: no-cache, must-revalidate");
header("Pragma: no-cache");
header("Content-Type: text/html; charset=${Charset}");

$DbLink = new DB;

$Latin1 = ($Charset == "iso-8859-1");
function special_char($str,$lang)
{
	return ($lang ? htmlentities($str) : htmlspecialchars($str));
}
?>
<HTML>

<HEAD>
<TITLE><?php echo(special_char(stripslashes($U),$Latin1)); ?></TITLE>
<LINK REL="stylesheet" HREF="config/style.css.php3?<?php echo("Charset=${Charset}&medium=${FontSize}"); ?>" TYPE="text/css">
<SCRIPT TYPE="text/javascript" LANGUAGE="javascript1.1">
<!--
// Put the focus at the message box in the input frame
function put_focus()
{
	with (window.opener)
	{
		focus();
		document.Form.M.focus();
	}
}
// -->
</SCRIPT>
</HEAD>

<BODY CLASS=frame onUnload="if (window.opener && !window.opener.closed) put_focus();">
<CENTER>

<?php
$DbLink->query("SELECT latin1,firstname,lastname,country,website,email,showemail,perms,rooms FROM ".C_REG_TBL." WHERE username='$U' LIMIT 1");
list($Latin1,$firstname,$lastname,$country,$website,$email,$showemail,$perms,$rooms) = $DbLink->next_record();
$DbLink->clean_results();

// ** Get the status of the users
$tag_open = "<I>";
$tag_close = "</I>";
switch ($perms)
{
	case "moderator":
		if (eregi($R,$rooms))
		{
			$perms = L_WHOIS_MODER;
		}
		else
		{
			$perms = L_WHOIS_USER;
			$tag_open = "";
			$tag_close = "";
		}
		break;
	case "admin":
		$perms = L_WHOIS_ADMIN;
		break;
	default:
		$perms = L_WHOIS_USER;
		$tag_open = "";
		$tag_close = "";
}
?>
<P CLASS=title><?php echo($tag_open.special_char(stripslashes($U),$Latin1).$tag_close); ?></P>
<P></P>
<TABLE BORDER=0>
<TR>
	<TD CLASS=whois nowrap><?php echo(L_REG_30); ?>: </TD>
	<TD CLASS=whois nowrap><?php echo(special_char($firstname,$Latin1)); ?></TD>
</TR>
<TR>
	<TD CLASS=whois nowrap><?php echo(L_REG_31); ?>: </TD>
	<TD CLASS=whois nowrap><?php echo(special_char($lastname,$Latin1)); ?></TD>
</TR>
<?php
if ($country)
{
	?>
	<TR>
		<TD CLASS=whois nowrap><?php echo(L_REG_36); ?>: </TD>
		<TD CLASS=whois nowrap><?php echo(special_char($country,$Latin1)); ?></TD>
	</TR>
	<?php
}
if ($showemail)
{
	?>
	<TR>
		<TD CLASS=whois nowrap>e-mail: </TD>
		<TD nowrap><A HREF="mailto:<?php echo(htmlspecialchars($email)); ?>"><?php echo(htmlspecialchars($email)); ?></A></TD>
	</TR>
	<?php
}
if ($website)
{
	?>
	<TR>
		<TD CLASS=whois nowrap><?php echo(L_REG_32); ?> : </TD>
		<TD nowrap><A HREF="http://<?php echo(htmlspecialchars(str_replace("javascript:", "", $website))); ?>" TARGET="_blank"><?php echo(htmlspecialchars($website)); ?></A></TD>
	</TR>
	<?
}
?>
</TABLE>
<BR>
<SPAN CLASS=whois><?php echo("> ${tag_open}${perms}${tag_close} <"); ?></SPAN>

</CENTER>
</BODY>

</HTML>
<?php
$DbLink->close();
?>